#Check for waxing a copper tool
#First an unwaxed item is searched for. This is indicated by the custom_data {cop:1}
#If found  then a honeycomb nearby is searched for.
#If everything passes, the tool will become waxed
execute as @e[type=item, predicate=patina_copper:copper_tool] at @s if function patina_copper:near_honeycomb run function patina_copper:waxing/wax

#Check for scrapping off wax from a waxed copper tool
#First a waxed item is searched for. This is indicated by the custom_data {cop:2}
#If found  then a flint nearby is searched for.
#If everything passes, the tool will become unwaxed
execute as @e[type=item, predicate=patina_copper:waxed_copper_tool] at @s if function patina_copper:near_scraper run function patina_copper:scraping/scrape
execute as @e[type=item, predicate=patina_copper:copper_tool] if predicate patina_copper:scrapeable_copper_tool at @s if function patina_copper:near_scraper run function patina_copper:scraping/scrape_oxidization

execute as @a if items entity @s weapon.mainhand minecraft:brush[!minecraft:custom_data="{cop:1}"] if items entity @s weapon.mainhand minecraft:brush[!minecraft:custom_data="{cop:2}"] run item modify entity @s weapon.mainhand patina_copper:waxing/patina_brush

#Detect if an uncharged Amethyst Cartridge is dropped onto a Lodestone
#If the CD from the previous charging sequence is not active and the nearest player has enough experience levels, the charging sequence will start
execute as @e[type=item, predicate=patina_copper:uncharged_casing] at @s if entity @p[level=3.., distance=..6, limit=1] if score pat pat.cas_charge_cd matches 0 run function patina_copper:charging/init_charge

#If the CD from the rejection is not active and the nearest player does not have enough experience levels, it will be rejected and the relevant logic will run
execute as @e[type=item, predicate=patina_copper:uncharged_casing] unless entity @s[tag=pat.cas_charging] at @s if entity @p[level=..2, distance=..6, limit=1] if score pat pat.cas_reject_cd matches 0 if score pat pat.cas_charge_cd matches 0 run function patina_copper:rejection

#Count down the Charging CDs
execute unless score pat pat.cas_reject_cd matches 0 run scoreboard players remove pat pat.cas_reject_cd 1
execute unless score pat pat.cas_charge_cd matches 0 run scoreboard players remove pat pat.cas_charge_cd 1

schedule function patina_copper:interaction_tick 5t